VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DB_Substitutes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private data_ As Excel.Worksheet

Public Function Init(target As Excel.Worksheet)
  Set data_ = target
End Function

Public Function IBegin() As IteratorSubstitute
  Set IBegin = New IteratorSubstitute
  Call IBegin.Init(data_)
End Function

Public Function ILast() As IteratorSubstitute
  Set ILast = New IteratorSubstitute
  Call ILast.Init(data_)
  Call ILast.GoLast
End Function

Public Function INew() As IteratorSubstitute
  Set INew = New IteratorSubstitute
  Call INew.Init(data_)
  Call INew.GoLast
  Call INew.Increment
End Function

Public Function Count() As Long
  Count = ILast.row_ - IBegin.row_ + 1
End Function

Public Function Clear()
  Call data_.UsedRange.Offset(1).ClearContents
End Function

Public Function ClearCounters()
  Dim sHeader$: sHeader = data_.Cells(1, S_MATCH_COUNTER)
  Call data_.Columns.Item(S_MATCH_COUNTER).ClearContents
  data_.Cells(1, S_MATCH_COUNTER) = sHeader
End Function

Public Function Processor() As ProcessorSubstitute
  Dim opts As New OptionsSubstitutes
  With opts
    .caseSensitive_ = ThisWorkbook.Names(CELL_MATCHCASE).RefersToRange
    .wholeWord_ = ThisWorkbook.Names(CELL_WHOLEWORD).RefersToRange
    .regex_ = ThisWorkbook.Names(CELL_REGEX).RefersToRange
    .mark_ = ThisWorkbook.Names(CELL_MARK_REPLACED).RefersToRange
  End With
  
  Dim iProcessor As New ProcessorSubstitute
  Call iProcessor.Init(opts, Me)
  Set Processor = iProcessor
End Function
