VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorSource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public row_ As Long
Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional tRow& = FIRST_ROW)
  Set data_ = target
  row_ = tRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function IncrementCounter(Optional inc& = 1)
  Counter = Counter + inc
End Function

Public Function GoFirst()
  row_ = FIRST_ROW
End Function

Public Function GoLast()
  row_ = data_.Columns(S_SRC_ID).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_SRC_ID) = vbNullString
End Function

Public Function RemoveRow()
  Call data_.Rows(row_).Delete
End Function

'===== Propertiy Get =====
Public Property Get SourceID() As Long
  SourceID = data_.Cells(row_, S_SRC_ID)
End Property

Public Property Get FileName() As String
  FileName = data_.Cells(row_, S_SRC_NAME)
End Property

Public Property Get Extension() As String
  Extension = data_.Cells(row_, S_SRC_EXTENSION)
End Property

Public Property Get Path() As String
  Path = data_.Cells(row_, S_SRC_PATH)
End Property

Public Property Get Counter() As Long
  Counter = data_.Cells(row_, S_SRC_COUNTER)
End Property

' ==== Property Let ====
Public Property Let SourceID(newVal&)
  data_.Cells(row_, S_SRC_ID) = newVal
End Property

Public Property Let FileName(newVal$)
  data_.Cells(row_, S_SRC_NAME) = newVal
End Property

Public Property Let Extension(newVal$)
  data_.Cells(row_, S_SRC_EXTENSION) = newVal
End Property

Public Property Let Path(newVal$)
  data_.Cells(row_, S_SRC_PATH) = newVal
  Call XLUpdateHyperlink(data_.Cells(row_, S_SRC_PATH), newVal)
End Property

Public Property Let Counter(newVal&)
  data_.Cells(row_, S_SRC_COUNTER) = newVal
End Property
