VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ProcessorFormatMine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements AProcessor

Private word_ As API_WordWrapper
Private doc_ As Word.Document

Private out_ As Excel.Worksheet
Private row_ As Long
Private format_ As MiningFormat

Public Function Init(iOut As Excel.Worksheet, iFormat As MiningFormat)
  Set word_ = New API_WordWrapper: Call word_.CreateApplication
  Set out_ = iOut
  row_ = FIRST_ROW
  format_ = iFormat
End Function

Public Function Finalize()
  Call word_.ReleaseApplication
End Function

Public Function AProcessor_ProcessSource(iSource As IteratorSource)
  If ApplicationFromExtension(iSource.Extension) <> T_APP_WORD Then _
    Exit Function
  
  Set doc_ = word_.OpenDocument(iSource.Path, bReadOnly:=True)
  If doc_ Is Nothing Then _
    Exit Function
    
  Dim iData As Collection: Set iData = FindAllIn(doc_.Range)
  Dim sText As Variant
  For Each sText In iData
    out_.Cells(row_, 1) = iSource.Path
    out_.Cells(row_, 2) = CStr(sText)
    row_ = row_ + 1
  Next sText
    
  Call word_.ReleaseDocument(bCloseApplication:=False)
End Function

' ======
Private Function FindAllIn(target As Word.Range) As Collection
  Dim iFound As Collection: Set iFound = New Collection
  
  Call SetupFindParams(target)
  Do While target.Find.Execute
    Call iFound.Add(TrimWhitespace(target.Text))
    Call target.Collapse(wdCollapseEnd)
  Loop
  
  Set FindAllIn = iFound
End Function

Private Function SetupFindParams(target As Word.Range)
  Call target.Find.ClearFormatting
  Select Case format_
  Case MiningFormat.MINE_HIGHLIGHT
    With target.Find
      .Text = ""
      .Format = True
      .Highlight = True
    End With
  
  Case MiningFormat.MINE_UNDERLINE
    With target.Find
      .Text = ""
      .Format = True
      .Font.Underline = wdUnderlineSingle
    End With
  End Select
End Function
  
