Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  MSG_OK = 0
  
  IM_FILES_CLEARED
  IM_FILES_UPDATED
  IM_SUBSTITUTES_MARKED
  IM_SUBSTITUTES_DONE
  IM_ORDERS_PROCESSED
  IM_CONVERT_EXTENSION
  IM_MASTERDOC
  IM_EXTRACT_SUCCESS
  
  EM_NO_PYTHON
  
 ' QM_CODE_DELETE_CONFIRM
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case IM_FILES_CLEARED:          Call MsgBox("  ", vbInformation)
  Case IM_FILES_UPDATED:          Call MsgBox(Fmt(" : {1} ", unwrapped), vbInformation)
  Case IM_SUBSTITUTES_MARKED:     Call MsgBox(" ", vbInformation)
  Case IM_SUBSTITUTES_DONE:       Call MsgBox(" ", vbInformation)
  Case IM_ORDERS_PROCESSED:       Call MsgBox(Fmt("    {1}", unwrapped), vbInformation)
  Case IM_CONVERT_EXTENSION:       Call MsgBox(Fmt(" : {1}/{2}", unwrapped), vbInformation)
  Case IM_MASTERDOC:              Call MsgBox(Fmt("  : {1}/{2}", unwrapped), vbInformation)
  Case IM_EXTRACT_SUCCESS:        Call MsgBox(Fmt("    {1}", unwrapped), vbInformation)
  
  Case EM_NO_PYTHON:              Call MsgBox("   .      ", vbExclamation)
      
  Case Else:                      Call MsgBox("Invalid message code", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
 ' Case QM_CODE_DELETE_CONFIRM
 '   answer = MsgBox("Are you sure you want to delete ALL macros from target file?", vbYesNo + vbQuestion)
    
  Case Else:   Call MsgBox("Invalid message code", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
